var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/web/control/src/index.ts
var src_exports = {};
__export(src_exports, {
  Config: () => Config,
  install: () => install,
  using: () => using
});
module.exports = __toCommonJS(src_exports);
var import_zhin2 = require("zhin");
var import_path = require("path");

// packages/web/control/src/authService.ts
var import_zhin = require("zhin");
var import_plugin_console = require("@zhinjs/plugin-console");
var import_plugin_database = require("@zhinjs/plugin-database");
var import_uuid = require("uuid");
var authFields = ["name", "authority", "user_id", "expire", "token"];
function setAuthUser(handle, value) {
  handle.user = value;
  handle.send({ type: "data", body: { key: "user", value } });
  handle.refresh();
  return true;
}
__name(setAuthUser, "setAuthUser");
var AuthService = class extends import_plugin_console.DataService {
  constructor(ctx, config) {
    super(ctx, "user");
    this.config = config;
    this.init();
    this.initLogin();
  }
  async init() {
    this.ctx.disposes.push(await this.ctx.zhin.beforeReady(async () => {
      this.ctx.disposes.push(await this.ctx.database.onCreated(() => {
        this.ctx.database.extend("User", {
          password: import_plugin_database.DataTypes.STRING,
          token: import_plugin_database.DataTypes.TEXT,
          expire: import_plugin_database.DataTypes.BIGINT
        });
      }));
    }));
  }
  initLogin() {
    const { ctx, config = { loginTokenExpire: import_zhin.Time.minute * 10, authTokenExpire: import_zhin.Time.week } } = this;
    const states = {};
    ctx.console.addListener("login/password", async function(user_id, password) {
      const userInstance = await ctx.database.model("User").findOne({ where: { user_id }, attributes: ["id", "password", ...authFields] });
      if (!userInstance)
        throw new Error("用户名错误。");
      const user = userInstance.toJSON();
      if (!user || user.password !== password)
        throw new Error("密码错误。");
      if (!user.expire || user.expire < Date.now()) {
        user.token = (0, import_uuid.v4)();
        user.expire = Date.now() + config.authTokenExpire;
        await userInstance.update((0, import_zhin.pick)(user, ["token", "expire"]));
      }
      setAuthUser(this, (0, import_zhin.omit)(user, ["password"]));
    });
    ctx.console.addListener("login/token", async function(user_id, token) {
      const userInstance = await ctx.database.model("User").findOne({ where: { user_id }, attributes: authFields });
      if (!userInstance)
        throw new Error("用户不存在。");
      const user = userInstance.toJSON();
      if (user.token !== token || user.expire <= Date.now())
        throw new Error("令牌已失效。");
      setAuthUser(this, user);
    });
    ctx.console.addListener("login/captcha", async function(user_id) {
      const userInstance = await ctx.database.model("User").findOne({ where: { user_id } });
      if (!userInstance)
        throw new Error("找不到此账户。");
      const user = userInstance.toJSON();
      const token = (0, import_uuid.v4)();
      const expire = Date.now() + config.loginTokenExpire;
      states[user_id] = [token, expire, this];
      const listener = /* @__PURE__ */ __name(() => {
        delete states[user_id];
        dispose();
        this.socket.removeEventListener("close", listener);
      }, "listener");
      const dispose = ctx.setTimeout(() => {
        var _a;
        if (((_a = states[user_id]) == null ? void 0 : _a[1]) >= Date.now())
          listener();
      }, config.loginTokenExpire);
      this.socket.addEventListener("close", listener);
      return { user_id: user.user_id, name: user.name, token, expire };
    });
    ctx.middleware(async (session, next) => {
      const state = states[session.user_id];
      if (state && state[0] === session.content) {
        const user = session.friend || session.member || session.user;
        if (!user.expire || user.expire < Date.now()) {
          user.token = (0, import_uuid.v4)();
          user.expire = Date.now() + config.authTokenExpire;
          await ctx.database.model("User").update({ token: user.token, expire: user.expire }, { where: { user_id: session.user_id } });
        }
        return setAuthUser(state[2], (0, import_zhin.omit)(user, ["password"]));
      }
      next();
    });
    ctx.on("console/intercept", (handle, listener) => {
      if (!listener.authority)
        return false;
      if (!handle.user)
        return true;
      if (handle.user.expire <= Date.now())
        return true;
      return handle.user.authority < listener.authority;
    });
    ctx.console.addListener("user/logout", async function() {
      if (!this.user.user_id)
        return;
      delete states[this.user.user_id];
      setAuthUser(this, null);
    });
    ctx.console.addListener("user/update", async function(data) {
      if (!this.user)
        throw new Error("请先登录。");
      await ctx.database.model("User").update(data, { where: { user_id: this.user.user_id } });
    });
  }
};
__name(AuthService, "AuthService");
AuthService.using = ["console", "database"];

// packages/web/control/src/index.ts
var import_plugin_console3 = require("@zhinjs/plugin-console");

// packages/web/control/src/configService.ts
var import_plugin_console2 = require("@zhinjs/plugin-console");
function setData(handler, options) {
  var _a, _b;
  if (!handler.user)
    throw new Error("请先登录。");
  if (handler.user.authority !== 7)
    throw new Error("权限不足");
  (_b = (_a = handler.ctx) == null ? void 0 : _a.zhin) == null ? void 0 : _b.changeOptions(options);
  handler.send({ type: "data", body: { key: "config", value: handler.ctx.zhin.options } });
  handler.refresh();
}
__name(setData, "setData");
var ConfigService = class extends import_plugin_console2.DataService {
  constructor(ctx) {
    super(ctx, "config");
    this.startListen();
  }
  startListen() {
    this.ctx.console.addListener("config/update", async function(options) {
      setData(this, options);
      return "修改成功";
    });
    this.ctx.console.addListener("config", function() {
      this.send({ type: "data", body: { key: "config", value: this.ctx.zhin.options } });
    });
  }
};
__name(ConfigService, "ConfigService");

// packages/web/control/src/index.ts
var using = ["console"];
var Config = import_zhin2.Schema.object({
  authTokenExpire: import_zhin2.Schema.number().description("鉴权token超时时间").default(import_zhin2.Time.minute * 10),
  loginTokenExpire: import_zhin2.Schema.number().default(import_zhin2.Time.week)
});
function install(ctx) {
  const config = Config((0, import_zhin2.useOptions)("services.consoleAuth"));
  ctx.console.addEntry((0, import_path.resolve)(__dirname, "../client/index.ts"));
  ctx.service("console.user", new AuthService(ctx, config));
  ctx.service("console.config", new ConfigService(ctx));
}
__name(install, "install");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Config,
  install,
  using
});
//# sourceMappingURL=index.js.map
